"{ Package: 'stx:goodies/petitparser/compiler' }"

"{ NameSpace: Smalltalk }"

PPCCompiler subclass:#PPCTokenizingCompiler
	instanceVariableNames:'rememberStrategy errorStrategy'
	classVariableNames:''
	poolDictionaries:''
	category:'PetitCompiler-Compiler'
!

!PPCTokenizingCompiler methodsFor:'code generation'!

codeClearError
    errorStrategy codeClearError
!

codeError
    errorStrategy codeError
!

codeError: message
    errorStrategy codeError: message.
!

smartRemember: parser to: variableName 
    rememberStrategy smartRemember: parser to: variableName
!

smartRestore: parser from: mementoName
    rememberStrategy smartRestore: parser from: mementoName
! !

!PPCTokenizingCompiler methodsFor:'hooks'!

compiledParserSuperclass
    ^ compiledParserSuperclass ifNil: [ PPTokenizingCompiledParser ]
!

errorStrategy
    ^ errorStrategy ifNil: [ PPCCompilerTokenizingErrorStrategy on: self  ]
!

errorStrategy: whatever
    errorStrategy := whatever 
!

rememberStrategy
    ^ rememberStrategy ifNil: [ PPCCompilerTokenizingRememberStrategy on: self  ]
!

rememberStrategy: whatever
    rememberStrategy := whatever 
! !

!PPCTokenizingCompiler methodsFor:'initialization'!

initialize
    super initialize.
    rememberStrategy := PPCCompilerTokenizingRememberStrategy on: self
! !

